// Alpha Treshold
// Jorge Fuente-Alba
// PS 2.0
// Remap Alpha and blend according to set values

// Foreground texture
texture ForegroundTexture;
//#PARAM percent start 0 : Start : Alpha value to start blending.
float start;
//#PARAM percent end 1 : End : Alpha value to finish blending.
float end;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};

// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
    // Add the front and back pixels
    float4 fore = tex2D(foreground, Tex.xy);
    fore.rgb = fore.rgb/fore.a;
    if ((end-start)==0)
    {
      fore.a = (fore.a<start);
    }
    else
    {
      fore.a = saturate((fore.a-start)/(end-start));
    }
    fore.rgb = fore.rgb*fore.a;
    return fore;
}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}
